//-----------------------------------------------------------------
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Blue//LimeGreen
#property  indicator_color2  Red//Gold
#property  indicator_width1  2
#property  indicator_width2  2
//-----------------------------------------------------------------

extern string              TimeFrame   = 0;
extern int                 pq          = 2;
extern int                 pr          = 10;
extern int                 ps          = 5;
extern int                 trigger     = 3;
extern bool   verticalLinesVisible     = true;//false;
extern string verticalLinesID          = "ECCILines";
extern color  verticalLinesUpColor     = Blue;//LimeGreen;
extern color  verticalLinesDnColor     = Red;//Orange;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 2;
extern bool   Interpolate              = true;

double ErgoCCI[];
double MainCCI[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,ErgoCCI);   SetIndexLabel(0,"Egodic CCI-M"+TimeFrame+"");
   SetIndexBuffer(1,MainCCI);   SetIndexLabel(1,"Trigger Line");
   SetIndexBuffer(2,trend);     SetIndexLabel(2,"b2-FXtrd");
      
      
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
  
   //string shortName = "RK-ml-FX Sniper's Erogodic CCI Trigger lines mtf "+timeFrameToString(timeFrame)+" ("+pq+") ("+pr+") ("+ps+") ("+trigger+")";
        
   //IndicatorShortName(shortName+")");
    return(0);
}
int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

int start()
{
   string signal;
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ErgoCCI[0] = limit+1; return(0); }
         if (timeFrame!= Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ErgoCCI[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,verticalLinesVisible,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,0,y);
                  MainCCI[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,verticalLinesVisible,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,1,y);
                  trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,verticalLinesVisible,verticalLinesID,verticalLinesUpColor,verticalLinesDnColor,verticalLinesStyle,verticalLinesWidth,2,y);
                  
                  //
                  //
                  //
                  //
                  //
      
                  if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                  //
                  //
                  //
                  //
                  //

                  datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                     for(int k = 1; k < n; k++)
                     {
                        ErgoCCI[i+k] = ErgoCCI[i] + (ErgoCCI[i+n]-ErgoCCI[i])*k/n;
                        MainCCI[i+k] = MainCCI[i] + (MainCCI[i+n]-MainCCI[i])*k/n;
                     }
            }
            IndicatorShortName( "FX Sniper's Erogodic CCI w/lines "+timeFrameToString(timeFrame)+" ("+pq+") ("+pr+") ("+ps+") ("+trigger+"): "+signal); 
            return(0);                  
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double var1  = iEma(iEma(iEma(        Close[i]-Close[i+1] ,pq,i,0),pr,i,1),ps,i,2);
      double var2  = iEma(iEma(iEma(MathAbs(Close[i]-Close[i+1]),pq,i,3),pr,i,4),ps,i,5);
         if (var2 != 0)
               ErgoCCI[i] = 500.0 * var1/var2;
         else  ErgoCCI[i] = 0;
               MainCCI[i] = iEma(ErgoCCI[i],trigger,i,6);
               trend[i] = trend[i+1];
                  if (MainCCI[i]<ErgoCCI[i]) trend[i] =  1;
                  if (MainCCI[i]>ErgoCCI[i]) trend[i] = -1;
         if (verticalLinesVisible)
         {
            ObjectDelete(verticalLinesID+":u:"+Time[i]);
            ObjectDelete(verticalLinesID+":d:"+Time[i]);
               if (trend[i] != trend[i+1] && trend[i]== 1) drawLine(":u:",i,verticalLinesUpColor);
               if (trend[i] != trend[i+1] && trend[i]==-1) drawLine(":d:",i,verticalLinesDnColor);
         }            
   }
   if (MainCCI[0] >  ErgoCCI[0]) signal = "SHORT";
   if (MainCCI[0] <  ErgoCCI[0]) signal = "LONG";
   if (MainCCI[0] == ErgoCCI[0]) signal = "NEUTRAL";
   IndicatorShortName( "FX Sniper's Erogodic CCI w/lines "+timeFrameToString(timeFrame)+" ("+pq+") ("+pr+") ("+ps+") ("+trigger+"): "+signal); 
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawLine(string add, int i,color theColor)
{
   string name = verticalLinesID+add+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][7];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}


string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}